.text

#define	__NR_read	3
#define __NR_write	4
#define __NR_pause	29
#define __NR_signal	48

#define SIGINT		2
#define SIGTERM		15

#define	EINTR		4

#define BUFFER		1024

.global	_start
_start:
	leal	sighandler,%ecx
	push	%ecx
	push	$SIGTERM
	popl	%ebx
	push	$__NR_signal
	popl	%eax
	pushl	%eax
	int	$0x80			// signal(SIGTERM,dumpexit)

	popl	%eax
	popl	%ecx
	push	$SIGINT
	popl	%ebx
	int	$0x80			// signal(SIGINT,dumpexit)	

	xorl	%ecx,%ecx
	andl	$0xfffffffc,%esp	// adjust ESP
	subl	$BUFFER,%esp

bufferloop:
	leal	(%esp,%ecx),%edi	// read buffer = %esp + %ecx
	pushl	%ecx

	/*
	 *  Call read
	 */
	movl	$BUFFER,%edx		// %edx = sizeof(buffer) = 1024
	movl	%edi,%ecx		// %ecx = buffer
	xorl	%ebx,%ebx		// %ebx = 0 = stdin
	push	$__NR_read		// push imm8
	popl	%eax

	int	$0x80			// read(0,buffer,1024)
	popl	%ecx

	cmpl	$-124,%eax
	jbe	noerror

	negl	%eax
	cmpl	$EINTR,%eax
	je	dumpexit

	jmp	bufferloop

noerror:
	or	%eax,%eax		// EOF
	jz	pause

	movl	%esp,%esi		// set up source
	subl	%eax,%esp		// %eax bytes has been filled
	andl	$0xfffffffc,%esp	// adjust ESP
	movl	%esp,%edi		// set up destination
	addl	%eax,%ecx		// update data length

	xorl	%ebx,%ebx
copyloop:
	movl	(%esi,%ebx),%eax
	movl	%eax,(%edi,%ebx)
	addl	$4,%ebx
	cmpl	%ecx,%ebx
	jl	copyloop

	jmp	bufferloop

sighandler:
	ret

pause:
	pushl	%ecx
	push	$__NR_pause
	pop	%eax
	int	$0x80			// pause()
	pop	%ecx
	// fall through

dumpexit:
	movl	%ecx,%edx
	movl	%esp,%ecx
	push	$1
	popl	%ebx
	push	$__NR_write
	popl	%eax
	int	$0x80			// write(1,esp_buffer,count)

	xorl	%ebx,%ebx
	xorl	%eax,%eax
	incl	%eax
	int	$0x80			// exit(0)

/*
 *  EOF
 */
